// Use Foreach
const { foreach } = require("./kit");

// Preset
const preset = {
  component: {
    context: `@/components`,
    suffix: /.vue$/,
  },
  store: {
    context: `@/pages`,
    suffix: /\S+\/store.js$/,
  },
  route: {
    context: `@/pages`,
    suffix: /\S+\/route.js$/,
  },
  utils: {
    context: `@/utils`,
    suffix: /.js$/,
  },
  style: {
    context: `@/sheet`,
    suffix: /variables.scss$/,
  },
  i18n: {
    context: `@/i18n`,
    suffix: /.js$/,
  },
};

/**
 * Alias Map
 * @param target {object}
 * @param configure {json}
 * ======== ======== ========
 */
function alias(target, configure) {
  if (target.store) {
    foreach(configure, (value, key) => {
      if (value === false) {
        return;
      }
      target.store.set(`@${key}`, value.context || preset[key].context);
    });
  }
}

// Export
module.exports = alias;
